###############################################################################
# (c) Copyright 2021 CERN for the benefit of the LHCb Collaboration           #
#                                                                             #
# This software is distributed under the terms of the GNU General Public      #
# Licence version 3 (GPL Version 3), copied verbatim in the file "COPYING".   #
#                                                                             #
# In applying this licence, CERN does not waive the privileges and immunities #
# granted to it by virtue of its status as an Intergovernmental Organization  #
# or submit itself to any jurisdiction.                                       #
###############################################################################

# DO NOT EDIT: File generated by new_lcg_version.py

# Make sure the toolchain is included only once
# (to avoid double changes to the environment)
include_guard(GLOBAL)

cmake_policy(PUSH)
cmake_policy(SET CMP0007 NEW)

message(STATUS "Entering ${CMAKE_CURRENT_LIST_FILE}")
if(NOT DEFINED LCG_VERSION)
  get_filename_component(LCG_VERSION "${CMAKE_CURRENT_LIST_DIR}" NAME)
endif()
if(NOT DEFINED LCG_PLATFORM)
  get_filename_component(LCG_PLATFORM "${CMAKE_CURRENT_LIST_FILE}" NAME_WE)
endif()
string(REPLACE "-" ";" _platform_bits "${LCG_PLATFORM}")
if(NOT DEFINED LCG_ARCHITECTURE)
  list(GET _platform_bits 0 LCG_ARCHITECTURE)
endif()
if(NOT DEFINED LCG_OS)
  list(GET _platform_bits 1 LCG_OS)
endif()
if(NOT DEFINED LCG_COMPILER)
  list(GET _platform_bits 2 LCG_COMPILER)
endif()
if(NOT DEFINED LCG_OPTIMIZATION)
  list(GET _platform_bits 3 LCG_OPTIMIZATION)
endif()

if(NOT DEFINED LHCB_PLATFORM)
  set(LHCB_PLATFORM ${LCG_PLATFORM})
endif()

string(REGEX REPLACE "-[^-]+\$" "" LCG_SYSTEM "${LCG_PLATFORM}")
string(REGEX REPLACE "-[^-]+\$" "" LCG_HOST "${LCG_SYSTEM}")

if("${LCG_LAYER}" STREQUAL "")
  set(LCG_VERSION_SUFFIX "")
else()
  set(LCG_VERSION_SUFFIX "_${LCG_LAYER}")
endif()

foreach(bit IN ITEMS VERSION LAYER ARCHITECTURE OS COMPILER OPTIMIZATION PLATFORM SYSTEM)
  if(DEFINED LCG_${bit})
    message(STATUS "LCG_${bit} -> ${LCG_${bit}}")
  endif()
endforeach()

set(LCG_releases_base "/cvmfs/lhcb.cern.ch/lib/lcg/releases" CACHE PATH "Where to look for LCG releases")
set(FRAGMENTS_DIR ${CMAKE_CURRENT_LIST_DIR}/../fragments)

#[[---.rst
Helper function to remove duplicated from a PATH-like variables
#---]]
macro(_dedup_env_path name)
  string(REPLACE ":" ";" _${name}_tmp "$ENV{${name}}")
  list(REMOVE_DUPLICATES _${name}_tmp)
  list(FILTER _${name}_tmp EXCLUDE REGEX "^$")
  string(REPLACE ";" ":" _${name}_tmp "${_${name}_tmp}")
  set(ENV{${name}} "${_${name}_tmp}")
  unset(_${name}_tmp)
endmacro()

include(${FRAGMENTS_DIR}/compiler/${LCG_VERSION}-${LCG_SYSTEM}.cmake)
include(${FRAGMENTS_DIR}/packages/${LCG_VERSION}${LCG_VERSION_SUFFIX}-${LCG_PLATFORM}.cmake)

_dedup_env_path(PATH)
_dedup_env_path(LD_LIBRARY_PATH)
_dedup_env_path(ROOT_INCLUDE_PATH)

message(STATUS "Writing ${CMAKE_BINARY_DIR}/toolchain/wrapper for ${CMAKE_SOURCE_DIR}")
file(WRITE ${CMAKE_BINARY_DIR}/toolchain/wrapper
"#!/bin/sh -e
export PATH=$ENV{PATH}
export LD_LIBRARY_PATH=$ENV{LD_LIBRARY_PATH}
export PYTHONPATH=$ENV{PYTHONPATH}
export PYTHONHOME=$ENV{PYTHONHOME}
export ROOT_INCLUDE_PATH=$ENV{ROOT_INCLUDE_PATH}
export FONTCONFIG_PATH=$ENV{FONTCONFIG_PATH}

exec \"\$@\"
")
execute_process(COMMAND chmod a+x ${CMAKE_BINARY_DIR}/toolchain/wrapper)

include(${FRAGMENTS_DIR}/compilation_flags.cmake)

set(CMAKE_SYSTEM_NAME ${CMAKE_HOST_SYSTEM_NAME})
set(CMAKE_SYSTEM_PROCESSOR ${CMAKE_HOST_SYSTEM_PROCESSOR})
set(CMAKE_CROSSCOMPILING_EMULATOR ${CMAKE_BINARY_DIR}/toolchain/wrapper)

# Allow definition of rule wrappers from cache variables
foreach(_action IN ITEMS COMPILE LINK CUSTOM)
  if(DEFINED CMAKE_RULE_LAUNCH_${_action})
    set_property(GLOBAL PROPERTY RULE_LAUNCH_${_action} "${CMAKE_RULE_LAUNCH_${_action}}")
  endif()
endforeach()

cmake_policy(POP)
